package BaseLayer.Example;

import BaseLayer.*;
import Abstract.*;

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class ChatterAppletAction extends BAgentAction  {
	
	// will be set by ChatterApplet
	ChatterApplet _applet;
	
	public ChatterAppletAction(Address hostaddr,String id)   {
		super(id,new BMessageBuffer(),new BAddressTable(),new BConnectionTable(),new BSecurity());
		try  {
			_security.setAddressTable(_addresses);
			_addresses.addAddress(hostaddr);
			_addresses.addAddress(new Address(id,"null",-1,"BRecvThread","(ChatterClient)"));
			createReceiverThread(hostaddr.getID(),Thread.NORM_PRIORITY);
		} catch (Exception e)  {
		}		
	}
	
	public void setApplet(ChatterApplet applet)  {
		_applet = applet;
	}
		
	// override. Just pass Message to the owner agent. 
	public void run()  {
		while(true)  {
				String newmsg = (String)_queue.waitForMessage();
System.out.println(newmsg + "\n");				
 				// Message format is sender,receiver,content
				StringTokenizer st = new StringTokenizer(newmsg,"\0");
				if(st != null)  {
		   		int nofToken = st.countTokens();
	     		String sender = st.nextToken();
	     		String content = st.nextToken();
	     		if(sender.equals("ChatterServer"))  {
		     		String additional = st.nextToken();
	     		
		     		if(content.equals("addConnection"))  {
	     				String args[] = new String[1];
	     				args[0] = additional;
							// agentFrame pass this content to Applet	     				
	     				_applet.processMessage("AddConnection",args);
	     			}
	     			else
	     			if(content.equals("removeConnection"))  {
		     			String args[] = new String[1];
	     				args[0] = additional;
	     				_applet.processMessage("RemoveConnection",args);
	     			}
	     			else  {
		     			// introduction
	     				_applet.notifyMessage("From::" + sender + "\n" + additional);	
	     			}		
	     		}
	     		else	{
						_applet.notifyMessage("From::" + sender + "\n" + content);
					}	
			}	
		}
	}			
	
	public void processMessage(String str,Object obj) {}
	protected boolean Act(Object o)  {
		return true;
	}	

}	
		
