package KQMLLayer.Example.SASync;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import BaseLayer.*;
import Abstract.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class SASyncConnectionDlg  extends Dialog implements ActionListener {

	AddressTable _addressTable;
	Hashtable _connectionTable; 

	TextField _id;
	TextField _host;
	TextField _port;
	
	TextField _username;
	TextField _password;
	
	Button _connectButton;
	Button _disconnectButton;
	Button _removeButton;
	Button _saveButton;
	Button _cancelButton;

	TextField _description;

	TextField _type;
		
	java.awt.List _addresses;
	java.awt.List _connections;
		
			
	public SASyncConnectionDlg(Frame mf,AddressTable addrs,Hashtable cons)  {
		super(mf,"JATLite",false);

		_addressTable = addrs;
		_connectionTable = cons;

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		
		c.insets = new Insets(5,5,5,5);
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;

		Label agentid = new Label("AgentID");
		makeComponent(agentid,gridbag,c);
	
		_id = new TextField("",10);
		makeComponent(_id,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_connectButton = new Button("Connect");
		_connectButton.addActionListener(this);
		makeComponent(_connectButton,gridbag,c);

		c.gridwidth = 1;
		Label host = new Label("Host");
		makeComponent(host,gridbag,c);
		
		_host = new TextField("",10);
		makeComponent(_host,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_disconnectButton = new Button("Disconnect");
		_disconnectButton.addActionListener(this);
		makeComponent(_disconnectButton,gridbag,c);
		
		c.gridwidth = 1;
		Label port = new Label("Port");
		makeComponent(port,gridbag,c);
		
		_port = new TextField("",10);
		makeComponent(_port,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_saveButton = new Button("Save");
		_saveButton.addActionListener(this);
		makeComponent(_saveButton,gridbag,c);

		c.gridwidth = 1;
		Label username = new Label("Username");
		makeComponent(username,gridbag,c);
		
		_username = new TextField("",10);
		makeComponent(_username,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_removeButton = new Button("Remove");
		makeComponent(_removeButton,gridbag,c);
		
		c.gridwidth = 1;
		Label password = new Label("Password");
		makeComponent(password,gridbag,c);
	
		_password = new TextField("",10);
		_password.setEchoChar('#');
		makeComponent(_password,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_cancelButton = new Button("Close");
		_cancelButton.addActionListener(this);
		makeComponent(_cancelButton,gridbag,c);
		
		
		c.gridwidth = 1;
		Label description = new Label("Description");
		makeComponent(description,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		
		_description = new TextField("",30);
		gridbag.setConstraints(_description,c);
		add(_description);
		
		c.gridwidth = 1;
		Label type = new Label("Type");
		makeComponent(type,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		
		_type = new TextField("BRecvThread",30);
		makeComponent(_type,gridbag,c);
				
		c.gridwidth = 2;
		Label addresses = new Label("Addresses");
		makeComponent(addresses,gridbag,c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		Label connections = new Label("Connections");
		makeComponent(connections,gridbag,c);
		
		c.gridwidth = 2;
		_addresses = new java.awt.List();
		_addresses.addActionListener(this);
	//	_addresses.setName("AddressList");
		makeComponent(_addresses,gridbag,c);
		Enumeration e = _addressTable.elements();
		while(e.hasMoreElements())  {
			Address already = (Address)e.nextElement();
			_addresses.add(already.getID());
		}	
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		_connections = new java.awt.List();
		_connections.addActionListener(this);
	//	_connections.setName("ConnectionList");
		makeComponent(_connections,gridbag,c);
		e = _connectionTable.keys();
		while(e.hasMoreElements())  {
			String id = (String)e.nextElement();
			_connections.add(id);
		}	
		
  }

	public void showDlg()  {
		pack();
		setSize(330,420);
		setVisible(true);
	}
	
	protected void makeComponent(Component c,
															 GridBagLayout gridbag,	
															 GridBagConstraints co)  {
			gridbag.setConstraints(c,co);
			add(c);
	}
	
	public void actionPerformed(ActionEvent evt)  {		
		SASyncFrameExample mf = (SASyncFrameExample)getParent();
		String arg = evt.getActionCommand();
		
		  if("Save".equals(arg))  {
				String addr[] = new String[5];
				addr[0] = _id.getText();
				addr[1] = _host.getText();
				addr[2] = _port.getText();
				addr[3] = _type.getText();
				addr[4] = "(userinfo :username ";
				addr[4] = addr[4] + _username.getText() + " :password " + _password.getText() + " :description " + _description.getText() + ")";
				mf.processMessage("AddAddress",addr);
				_addresses.add(addr[0]);
			}			
			else 
			if("Close".equals(arg)) {
				dispose();
			}	
			else
			if("Remove".equals(arg))  {
				int no = _addresses.getSelectedIndex();
				String addr[] = new String[1];
				addr[0] = _addresses.getSelectedItem();		
				if(addr[0] != null)  {		
					mf.processMessage("RemoveAddress",addr);
					_addresses.delItem(no);
				}	
			}
			else
			if("Disconnect".equals(arg))  {
				int no = _connections.getSelectedIndex();
				String addr[] = new String[1];
				addr[0] = _connections.getSelectedItem();
				if(addr[0] != null)  {
					mf.processMessage("Disconnect",addr);
					_connections.delItem(no);	
				}	
			}
			
			else
			if("Connect".equals(arg))  {
				String addr[] = new String[5];
				addr[0] = _id.getText();
				addr[1] = _host.getText();
				addr[2] = _port.getText();
				addr[3] = _type.getText();
				addr[4] = "(userinfo :username ";
				addr[4] = addr[4] + _username.getText() + " :password " + _password.getText() + " :description " + _description.getText() + ")";
				mf.processMessage("Connect",addr);
				_connections.add(addr[0]);
			}
			else  {
				Address addr = (Address)_addressTable.getAddress(_addresses.getSelectedItem());
				if(addr != null)  {
					_id.setText(addr.getID());
					_host.setText(addr.getHost());
					_port.setText(Integer.toString(addr.getPort()));
					_description.setText(addr.getDescription());
					_type.setText(addr.getType());
				}	
		 }
		} 	
}	
