package KQMLLayer.Example.SASyncApplet;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.applet.*;
import java.net.*;
import java.util.*;

import Abstract.*;
import KQMLLayer.*;
import BaseLayer.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class SASyncApplet extends Applet implements ActionListener {

	TextField _connection;
	TextArea _sendArea;
	TextArea _receiveArea;
	String _currentReceiver;
	SASyncAppletExample _agentAction;
	String _myname;
	

  public SASyncApplet(){
  }

  public void init()  {
    connectToServer();
	
    Panel buttonPanel = new Panel();
    buttonPanel.setLayout(new GridLayout(1,4));
    
    _connection = new TextField(_currentReceiver,10);
    buttonPanel.add(_connection);
    
    Button compose = new Button("Compose");
    compose.addActionListener(this);
    Button send = new Button("Send");
    send.addActionListener(this);
    Button quit = new Button("Quit");
    quit.addActionListener(this);
    
    buttonPanel.add(compose);
    buttonPanel.add(send);
    buttonPanel.add(quit);
    
    add("North",buttonPanel);
		
		_receiveArea = new TextArea("Receiving Area\n",10,60);
		add("Center",_receiveArea);
		
		_sendArea = new TextArea("Sending Area\n",10,60);
		add("South",_sendArea);
		
  }


  /**
  * ActionPerformed implementation
  */
	public void actionPerformed(ActionEvent event) {
      String source = event.getActionCommand();

      if(source.equals("Compose"))  {
					String defaultMessage = "tell \r\n";
        	defaultMessage = defaultMessage + " :sender " + _myname + " \r\n";
        	defaultMessage = defaultMessage + " :receiver " + _currentReceiver + " \r\n";
        	defaultMessage = defaultMessage + " :language KQML \r\n";
        	defaultMessage = defaultMessage + " :content (       )";
        	_sendArea.setText(defaultMessage);
      }
      else
      if(source.equals("Send"))  {
        	String sendstr = _sendArea.getText();
        	int strlen = sendstr.length();
        	String cstr = "(";
					cstr = cstr + filtering(sendstr) + ")";
					try  {
        		_agentAction.sendMessage(_currentReceiver,cstr);
        	}  catch (ConnectionException c)  {
        		System.out.println(c.toString());	
      	}
      }
      else
      if(source.equals("Quit"))  {
        	_agentAction.endAction();
        	stop();
     } 
  }  

  protected String filtering(String sendstr) {
    String retstr ="";
    int strlen = sendstr.length();
    for(int i=0; i < strlen; i++)  {
			char c = sendstr.charAt(i);
			if((c != '\r') && (c != '\n')) {
	  	retstr = retstr + c;
	  	}	
	  }	
    return retstr;
  }
 
 
 public void run()  {
 }

  protected void connectToServer()  {
    try  {
        _myname = getParameter("USERNAME");
        String servername = getParameter("SERVERNAME");
        String server = getParameter("SERVER");
        String port = getParameter("PORT");
        String type = getParameter("TYPE");
        String description = getParameter("DESCRIPTION");
				Address addr = new Address(servername,server,(Integer.valueOf(port)).intValue(),type,description);
				// give server address and my name
				_agentAction = new SASyncAppletExample(addr,_myname,this);
 				_agentAction.start();
				_currentReceiver = servername;
    } catch (Exception e)  {
        showStatus("Initialization Failed. Server not responding...");
        stop();
    }
  }

	public void processMessage(KQMLmessage kqml)  {
		_receiveArea.setText("-------------------------------\n" + kqml.getReadString());
	}
		

  public void stop()  {
  }

}