/**
 * @(#)NullButtonFace.java	2.2 11/25/96 Rodney Ryan (rer@interport.net)
 *
 * Copyright (c) 1996 Rodney Ryan, All Rights Reserved.
 *
 */

package RouterLayer.AgentClient.Example.RCApplet.extawt;

import java.awt.*;

/**
 * Provides a "no button face" for testing purposes. It is a Singleton.
 *
 * @author 	Rodney Ryan (rer@interport.net)
 * @version 	2.2 11/25/96
 *
 */
public class NullButtonFace extends Object implements ButtonFace
{

    /**
    * The distributed instance of the NullButtonFace.
    */
    private static NullButtonFace instance = null;

    /**
    * The size of the NullButtonFace.
    */
    private Dimension size = new Dimension(14, 14);

    /**
    * NullButtonFace is a Singleton - private Constructor.
    */
    private NullButtonFace()
    {
        super();
    }

    /**
    * Empty method.
    */
    public void paint(Graphics g,
                      boolean  disabled,
                      boolean  pressed)
    {
    }

    /**
    * Returns the size of the NullButtonFace.
    */
    public Dimension size()
    {
        return size;
    }

    /**
    * Returns the distributed instance of the NullButtonFace using
    * lazy initialization.
    */
    public static NullButtonFace instance()
    {
        if (instance == null)
            instance = new NullButtonFace();
        return instance;
    }
}