/**
 * @(#)TabPanel.java	2.2 11/25/96 Rodney Ryan (rer@interport.net)
 *
 * Copyright (c) 1996 Rodney Ryan, All Rights Reserved.
 *
 */

package RouterLayer.AgentClient.Example.RCApplet.extawt;

import java.awt.*;

/**
 * This provides a placeholder for the selected tabs matching Component.
 *
 * @author 	Rodney Ryan (rer@interport.net)
 * @version 	2.2 11/25/96
 *
 */
public class TabPanel extends Panel
{

    /**
    * Constructs a new TabPanel.
    */
    public TabPanel()
    {
        super();
    }

    /**
    * Paints the TabPanel.
    * @param g the Graphics instance
    */
    public void paint(Graphics g)
    {
        super.paint(g);
        Rectangle area = bounds();
        // fill in background
        g.setColor(getBackground());
        g.fillRect(0, 0, area.width, area.height);
        // upper and left sides lit
        g.setColor(Color.white);
        g.drawLine(0, 0, 0, area.height - 1);
        // lower and right sides shadowed
        g.setColor(Color.gray);
        g.drawLine(1, area.height - 2, area.width - 2, area.height - 2);
        g.drawLine(area.width - 2, area.height - 2, area.width - 2, 0);
        // shadow for lower and right side
        g.setColor(Color.black);
        g.drawLine(0, area.height - 1, area.width - 1, area.height - 1);
        g.drawLine(area.width - 1, area.height - 1, area.width - 1, 0);
    }

    /**
    * Returns the specified insets of (3, 5, 5, 5) to provide
    * a small border.
    */
    public Insets insets()
    {
        return new Insets(3, 5, 5, 5);
    }
}