package Setup;

import java.awt.*;
import java.awt.event.*;

import RouterLayer.AgentClient.Example.RCApplet.extawt.*;

import ProtocolLayer.*;

import java.util.*;
/**
* FTP setup panel
*/

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
* 
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/ 

public class SetupFTPPanel extends Panel {
	//GUI variables
	private Font normFont = new Font("Dialog",Font.PLAIN,10),
				 boldFont = new Font("Dialog",Font.BOLD,10),
				 ultraFont = new Font("Times", Font.PLAIN,18),
				 ultraBoldFont = new Font("Times", Font.BOLD,18),
				 bigFont = new Font("Times",Font.PLAIN,14),
				 bigBoldFont = new Font("Times",Font.BOLD,14);
	Color bkgColor = new Color(210,210,210);
	
	TextField _conID;
	TextField _remotePath;
	TextField _localPath;
	TextField _userName;
	TextField _password;
	TextField _host;
	TextField _port;
	TextField _email;
	
	SetupFrame _setupFrame;
	
	public SetupFTPPanel(SetupFrame frame)  	{	
		setLayout(new BorderLayout());
			
		_setupFrame = frame;
					
		add("Center", ftpPanels());
		
	}

	public FTPCon getFTPCon()  {
		return getText();
	}
														
	protected void setText(FTPCon con)  {
		_conID.setText(con.getID());
		_remotePath.setText(con.getRemotePath());
		_host.setText(con.getHost());
		_port.setText(Integer.toString(con.getPort()));
		_userName.setText(con.getUserName());
		_password.setText(con.getPassword());
		_localPath.setText(con.getLocalPath());
	}
	
			
	public FTPCon getText()  {
		FTPCon con = new FTPCon();
		con.setID("JATLiteFTP");
		con.setRemotePath(_remotePath.getText());
		con.setLocalPath(_localPath.getText());
		con.setHost(_host.getText());
		String port = _port.getText();
		if(port.equals(""))  {
			SetupMessageBox b = new SetupMessageBox("Port number is missing. 21 is assumed",_setupFrame);
			port = "21"; 
		}	
		con.setPort((Integer.valueOf(port)).intValue());
		con.setUserName(_userName.getText());
		con.setPassword(_password.getText());

		return con;	
	}
	
	public String getEmail()  {
		return _email.getText();
	}
		
	protected Panel ftpPanels()  	{
		Panel wholePanel = newPackerPanel();
		wholePanel.setBackground(bkgColor);
		
		Panel emailPanel = newPackerPanel();
		Label email = new Label("Email :", Label.RIGHT);
		_email = new TextField("YourEmailAddress",15);
		emailPanel.add("label;side=right", _email);
		emailPanel.add("label;side=right;padx=5", email);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", emailPanel);

		Panel remotePanel = newPackerPanel();
		Label remote = new Label("RemotePath:", Label.RIGHT);
		_remotePath = new TextField("",25);
		remotePanel.add("label;side=right;fill=both", _remotePath);
		remotePanel.add("label;side=right;fill=both;padx=2;anchor=e", remote);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", remotePanel);
		
		Panel localPanel = newPackerPanel();
		Label local = new Label("LocalDir:", Label.RIGHT);
		_localPath = new TextField("",25);
		localPanel.add("label;side=right;fill=both", _localPath);
		
		localPanel.add("label;side=right;fill=both;padx=2;anchor=e", local);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", localPanel);
		
		Panel hostPanel = newPackerPanel();
		Label host = new Label("Host:", Label.RIGHT);
		_host = new TextField("",15);
		Label port = new Label("Port:", Label.RIGHT);
		_port = new TextField("21",5);
		hostPanel.add("label;side=right;fill=both", _port);
		hostPanel.add("label;side=right;fill=both;padx=2;anchor=e", port);
		hostPanel.add("label;side=right;fill=both", _host);
		hostPanel.add("label;side=right;fill=both;padx=2;anchor=e", host);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", hostPanel);
		
		Panel userPanel = newPackerPanel();
		Label username = new Label("User:", Label.RIGHT);
		_userName = new TextField("",10);
		Label password = new Label("Password:", Label.RIGHT);
		_password = new TextField("",10);
		_password.setEchoChar('#');
		userPanel.add("label;side=right;fill=both", _password);
		userPanel.add("label;side=right;fill=both;padx=2;anchor=e", password);
		userPanel.add("label;side=right;fill=both", _userName);
		userPanel.add("label;side=right;fill=both;padx=2;anchor=e", username);
		wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", userPanel);
		
		return wholePanel;
	}

				
	public Insets insets()   	{
    	return new Insets(10, 10, 10, 10);
 	}
  
 	private Panel newPackerPanel()	{
		Panel p = new Panel();
		p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.PackerLayout());
		return p;
	}	
}	
				